<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des catégories</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total de catégories : {{ total }}</h3>
        <div class="column is-narrow">
          <nuxt-link
            :to="{ name: 'profil-dashboard-corps-creer', params: { profil: 'admin' } }"
            tag="button"
            class="is-primary button"
          >
            <b-icon icon="plus" />&nbsp;&nbsp;Créer une catégorie
          </nuxt-link>
        </div>
      </div>
      <mt-list v-slot="{ item: corp }" :list="corps">
        <mt-list-item>
          <div class="columns is-vcentered">
            <nuxt-link
              :to="{ name: 'profil-dashboard-corps-id-editer', params: { profil: 'admin', id: corp.id } }"
              class="columns column mt-marginless-bottom"
            >
              <div class="column">
                <span>&nbsp;{{ corp.code }}</span>
              </div>
              <div class="column">
                {{ corp.libelle }}
              </div>
              <div class="column">
                {{ corp.ordre }}
              </div>
              <div class="column">
                {{ corp.lettre }}
              </div>
            </nuxt-link>
            <div class="column is-narrow">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(corp)">Supprimer</b-button>
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerCorps(monCorps)">
        Êtes-vous certain(e) de vouloir supprimer la catégorie ?
      </mt-modal-action>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Corps suivants"
        aria-previous-label="Corps précedents"
        aria-page-label="Corps"
        aria-current-label="Page courante"
        @change="getCorps"
      />
    </div>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const { content: corps, totalElements: total, numberOfElements: nombrePageCourante } = await $api.corps.all(
      pageCourante - 1,
      parPage,
    );
    return {
      corps,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      monCorps: null,
    };
  },
  methods: {
    async getCorps(page) {
      this.pageCourante = page;
      ({
        content: this.corps,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.corps.all(this.pageCourante - 1, this.parPage));
    },
    confirmeSupprimer(corps) {
      this.ouvertDelete = true;
      this.monCorps = corps;
    },
    async supprimerCorps(corp) {
      try {
        await this.$api.corps.delete(corp.id);
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getCorps(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.mt-marginless-bottom {
  margin-bottom: 0;
}

/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
</style>
